routes/web.php
<?php

use Illuminate\Support\Facades\Route;

$this->settingRole = config("settings.role");

// Route::group([
//     "namespace" => "Home",
//     "as" => "home.",
// ], function () {
//     Route::get("/", ["uses" => "DashboardsController@index"])->name("index");
// });

Route::namespace("Auth")->group(function () {
    Route::get("/", ["uses" => "LoginController@showLoginForm"])->name("home.index");
    Route::get("login", 'LoginController@showLoginForm')->name("login");
    Route::post("login", 'LoginController@login')->name("login");
    Route::post("logout", 'LoginController@logout')->name("logout");
});

Route::middleware(["auth"])->group(function () {
    //Administrator
    Route::group([
        "middleware" => ["role:" . implode("|", $this->settingRole)],
        "namespace" => "Administrator",
        "as" => "administrator.",
        "prefix" => "administrator"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("dashboards", "DashboardsController")->only(["index"]);

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update", "ProfileController@update")->name("update");
            Route::delete("/destroy", "ProfileController@updatePassword")->name("destroy");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });

        Route::group([
            "middleware" => ["role:" . $this->settingRole["superadmin"]],
        ], function () {
            Route::resource("roles", "RolesController")->except(["show"]);
            Route::resource("permissions", "PermissionsController")->except(["show"]);
        });

        Route::resource("users", "UsersController")->only(["index", "destroy"]);
        Route::group([
            "as" => "users.",
            "prefix" => "users"
        ], function () {
            Route::put("/{id}/update-password", "UsersController@updatePassword")->name("update-password");
            Route::put("/{id}/update-status", "UsersController@updateStatus")->name("update-status");
            Route::put("/{id}/update-avatar", "UsersController@updateAvatar")->name("update-avatar");

            Route::get("/admin", "UsersController@adminIndex")->name("admin.index");
            Route::get("/admin/create", "UsersController@adminCreate")->name("admin.create");
            Route::post("/admin/create", "UsersController@adminStore")->name("admin.store");
            Route::get("/admin/{id}/edit", "UsersController@adminEdit")->name("admin.edit");
            Route::put("/admin/{id}/edit", "UsersController@adminUpdate")->name("admin.update");

            Route::get("/participant", "UsersController@participantIndex")->name("participant.index");
            Route::get("/participant/create", "UsersController@participantCreate")->name("participant.create");
            Route::post("/participant/create", "UsersController@participantStore")->name("participant.store");
            Route::get("/participant/{id}/edit", "UsersController@participantEdit")->name("participant.edit");
            Route::put("/participant/{id}/edit", "UsersController@participantUpdate")->name("participant.update");
        });

        Route::resource("sessions", "SessionsController");
        Route::resource("types", "TypesController");

        Route::resource("categories", "CategoriesController")->only(["show", "edit", "update", "destroy"]);
        Route::get("categories/{typeId}/create", "CategoriesController@create")->name("categories.create");
        Route::post("types/{typeId}", "CategoriesController@store")->name("categories.store");

        Route::resource("questions", "QuestionsController")->only(["edit", "update", "destroy"]);
        Route::get("questions/{categoryId}/create", "QuestionsController@create")->name("questions.create");
        Route::post("categories/{categoryId}", "QuestionsController@store")->name("questions.store");
        Route::post("questions/upload-image", "QuestionsController@uploadImage")->name("questions.upload-image");

        Route::resource("answers", "AnswersController")->except(["show"]);
    });

    //Participant
    Route::group([
        "middleware" => ["role:Participant"],
        "namespace" => "Participant",
        "as" => "participant.",
        "prefix" => "participant"
    ], function () {
        Route::get("/", "DashboardsController@index")->name("dashboards");
        Route::resource("types", "TypesController");

        Route::group([
            "as" => "profile.",
            "prefix" => "profile"
        ], function () {
            Route::get("/", "ProfileController@index")->name("index");
            Route::put("/update-password", "ProfileController@updatePassword")->name("update-password");
            Route::put("/update-avatar", "ProfileController@updateAvatar")->name("update-avatar");
        });
    });
});

app/Http/Controllers/Administrator/AnswersController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Models\Answer;

class AnswersController extends Controller
{
    public function index(Request $request)
    {
        return view(
            "administrator.answers.index"
        )->with("i", ($request->input("page", 1) - 1) * 5);
    }

    public function create()
    {
        return view(
            "administrator.answers.create"
        );
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            "name" => "required|unique:roles,name"
        ]);
        Answer::create([
            "name" => $request->input("name"),
            "guard_name" => "web"
        ]);

        return redirect()->route(
            "administrator.answers.index"
        )->with("success", "Answers created successfully.");
    }

    public function edit($id)
    {
        $answer = Answer::findOrFail($id);
        return view(
            "administrator.answers.edit",
            compact("answer")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $answer = Answer::findOrFail($id);
        $answer->name = $request->input("name");
        $answer->save();

        return redirect()->route(
            "administrator.answers.edit",
            $Answer->id
        )->with("success", "Answer updated successfully.");
    }

    public function destroy($id)
    {
        Answer::findOrFail($id)->delete();
        return redirect()->route(
            "administrator.answers.index"
        )->with("success", "Answer deleted successfully.");
    }
}

app/Http/Controllers/Administrator/CategoriesController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Models\Category;
use App\Models\Type;
use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

class CategoriesController extends Controller
{
    public function create($typeId)
    {
        $type = Type::findOrFail($typeId);
        return view(
            "administrator.categories.create",
            compact("type")
        );
    }

    public function store(Request $request, $typeId)
    {
        $type = Type::findOrFail($typeId);
        $this->validate($request, [
            "name" => "required|string",
            "time" => "nullable|integer",
            "description" => "nullable|string",
            "rule" => "nullable|string",
            "example" => "nullable|string",
        ]);

        Category::updateOrCreate([
            "type_id" => $type->id,
            "name" => $request->name,
            "time" => $request->time ?? NULL,
            "description" => $request->description,
            "rule" => $request->rule,
            "example" => $request->example
        ]);

        return redirect()->route(
            "administrator.types.show",
            $type->id
        )->with("success", "Exam category type created successfully.");
    }

    public function show($id)
    {
        $category = Category::findOrFail($id);
        return view('administrator.categories.show', compact('category'));
    }

    public function edit($id)
    {
        $category = Category::findOrFail($id);
        $types = Type::pluck("name", "id");

        return view(
            'administrator.categories.edit',
            compact('category', 'types')
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "type" => "required|exists:types,id",
            "name" => "required|string",
            "time" => "nullable|integer",
            "description" => "nullable|string",
            "rule" => "nullable|string",
            "example" => "nullable|string",
        ]);

        $category = Category::updateOrCreate(
            [
                "id" => $id
            ],
            [
                "type" => $request->type,
                "name" =>  $request->name,
                "time" =>  $request->time ?? NULL,
                "description" =>  $request->description,
                "rule" =>  $request->rule,
                "example" =>  $request->example
            ]
        );

        return redirect()->route(
            "administrator.categories.edit",
            $category->id
        )->with("success", "Exam category type updated successfully.");
    }

    public function destroy($id)
    {
        $category = Category::findOrFail($id);
        $typeId = $category->type->id;
        $category->delete();

        return redirect()->route(
            'administrator.types.show',
            $typeId
        )->with("success", "Exam category type deleted successfully.");
    }
}

app/Http/Controllers/Administrator/DashboardsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Config;

use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;

use App\User;
use App\Models\Session;
use App\Models\Type;

class DashboardsController extends Controller
{
    public function __construct()
    {
        $this->settingRole = config("settings.role");

        $this->middleware(function ($request, $next) {
            $this->authUserRole = auth()->user()->roles->first()->name;
            return $next($request);
        });
    }

    public function index()
    {
        $authUserRole = $this->authUserRole;
        if ($authUserRole === $this->settingRole["superadmin"]) {
            $permissions = Permission::all();
            $roles = Role::all();
            $users = User::all();

            $compact = compact("users", "permissions", "roles");
        } else {
            $users = User::whereHas(
                "roles",
                function ($role) {
                    $role->where("name", "!=", $this->settingRole["superadmin"]);
                }
            )->get();

            $compact = compact("users");
        }

        $sessionCount = Session::count();
        $participantCount = User::whereHas("roles", function ($roles) {
                                    $roles->where("name", "participant");
                                }
                            )->count();
        $typeCount = Type::count();

        return view(
            "administrator.dashboards.index",
            compact('sessionCount', 'participantCount', 'typeCount')
        );
    }
}

app/Http/Controllers/Administrator/PermissionsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use Spatie\Permission\Models\Permission;

class PermissionsController extends Controller
{
    function __construct()
    {
        $this->middleware("permission:permission-list|permission-create|permission-edit|permission-delete", ["only" => ["index", "store"]]);
        $this->middleware("permission:permission-create", ["only" => ["create", "store"]]);
        $this->middleware("permission:permission-edit", ["only" => ["edit", "update"]]);
        $this->middleware("permission:permission-delete", ["only" => ["destroy"]]);
    }

    public function index(Request $request)
    {
        $permissions = Permission::orderBy("name")->paginate(10);
        return view(
            "administrator.permissions.index",
            compact("permissions")
        )->with("i", ($request->input("page", 1) - 1) * 5);
    }

    public function create()
    {
        return view(
            "administrator.permissions.create"
        );
    }

    public function store(Request $request)
    {
        $this->validate($request, [
            "name" => "required|unique:roles,name"
        ]);
        Permission::create([
            "name" => $request->input("name"),
            "guard_name" => "web"
        ]);

        return redirect()->route(
            "administrator.permissions.index"
        )->with("success", "Permission created successfully.");
    }

    public function edit($id)
    {
        $permission = Permission::findOrFail($id);
        return view(
            "administrator.permissions.edit",
            compact("permission")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $permission = Permission::findOrFail($id);
        $permission->name = $request->input("name");
        $permission->save();

        return redirect()->route(
            "administrator.permissions.edit",
            $permission->id
        )->with("success", "Permission updated successfully.");
    }

    public function destroy($id)
    {
        Permission::findOrFail($id)->delete();
        return redirect()->route(
            "administrator.permissions.index"
        )->with("success", "Permission deleted successfully.");
    }
}

app/Http/Controllers/Administrator/QuestionsController.php
<?php

namespace App\Http\Controllers\Administrator;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;

use App\Models\Category;
use App\Models\Question;

class QuestionsController extends Controller
{
    public function create($categoryId)
    {
        $category = Category::findOrFail($categoryId);
        return view(
            "administrator.questions.create",
            compact("category")
        );
    }

    public function store(Request $request, $categoryId)
    {
        $category = Category::findOrFail($categoryId);
        $this->validate($request, [
            "description" => "required",
            "answer_type" => "required|in:vertical,horizontal"
        ]);

        Question::create([
            "category_id" => $category->id,
            "description" => $request->input("description"),
            "answer_type" => strtolower($request->answer_type)
        ]);

        return redirect()->route(
            "administrator.categories.show",
            $category->id
        )->with("success", "Questions created successfully.");
    }

    public function edit($id)
    {
        $question = Question::findOrFail($id);
        return view(
            "administrator.questions.edit",
            compact("question")
        );
    }

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            "name" => "required"
        ]);

        $question = Question::findOrFail($id);
        $question->name = $request->input("name");
        $question->save();

        return redirect()->route(
            "administrator.questions.edit",
            $question->id
        )->with("success", "Question updated successfully.");
    }

    public function destroy($id)
    {
        $question = Question::findOrFail($id);
        $categoryId = $question->category->id;
        $question->delete();

        return redirect()->route(
            "administrator.categories.show",
            $categoryId
        )->with("success", "Question deleted successfully.");
    }

    public function uploadImage(Request $request)
    {
        if ($request->hasFile("file")) {
            $fileName = date("Y_m_d_His") . "_" . uniqid() . "." . $request->file("file")->extension();

            $filePath = $request->file("file")->storeAs(
                "storage/images/questions",
                $fileName,
                "public"
            );

            return json_encode(["location" => url($filePath)]);
        }
    }
}

resources/views/administrator/types/create.blade.php
@extends('administrator.layouts.template')

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="page-title-box">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item"><a href="{{ route('administrator.types.index') }}">Tipe Ujian</a></li>
                        <li class="breadcrumb-item active">Tambah</li>
                    </ol>
                </div>
                <h4 class="page-title">Tambah Tipe Ujian</h4>
            </div>
        </div>
    </div>

    @if ($errors->all())
    <div class="row">
        <div class="col-12">
            <div class="alert alert-danger alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-alert-circle mr-2"></i>
                Something went wrong!
            </div>
        </div>
    </div>
    @endif

    <div class="row">
        <div class="col-sm-12">
            <div class="card-box">
                <div class="form-wrapper">
                    <form method="POST" action="{{ route('administrator.types.store') }}">
                        @csrf
                        <div class="row">
                            <div class="col-sm-12">
                                <strong class="text-muted d-block mb-2">Nama</strong>
                                <div class="form-group">
                                    <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" placeholder="Nama" value="{{ old('name') }}">

                                    @error("name")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-12">
                                <strong class="text-muted d-block mb-2">Deskripsi</strong>
                                <div class="form-group">
                                    <textarea type="description" rows="5" name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Deskripsi tipe ujian...">{{ old('description') }}</textarea>

                                    @error("description")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </div>

                        <div class="form__action">
                            <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                <i class="mdi mdi-content-save mr-1"></i>Simpan
                            </button>
                            <a class="btn btn-secondary waves-effect waves-light text-white mt-1 mb-1" href="{{ route('administrator.types.index') }}">
                                <i class="mdi mdi-reply mr-1"></i>Batal
                            </a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/administrator/types/edit.blade.php
@extends('administrator.layouts.template')

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="page-title-box">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item"><a href="{{ route('administrator.types.index') }}">Tipe Ujian</a></li>
                        <li class="breadcrumb-item active">Edit</li>
                    </ol>
                </div>
                <h4 class="page-title">Edit Tipe Ujian</h4>
            </div>
        </div>
    </div>

    @if ($message = session()->get("success"))
    <div class="row">
        <div class="col-12">
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-check-all mr-2"></i>
                {{ $message }}
            </div>
        </div>
    </div>
    @endif

    @if ($errors->all())
    <div class="row">
        <div class="col-12">
            <div class="alert alert-danger alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-alert-circle mr-2"></i>
                Something went wrong!
            </div>
        </div>
    </div>
    @endif

    <div class="row">
        <div class="col-sm-12">
            <div class="card-box">
                <div class="form-wrapper">
                    <form method="POST" action="{{ route('administrator.types.update', $type->id) }}">
                        @csrf
                        @method('PUT')
                        <div class="row">
                            <div class="col-sm-12">
                                <strong class="text-muted d-block mb-2">Nama</strong>
                                <div class="form-group">
                                    <input type="text" name="name" class="form-control @error('name') is-invalid @enderror" placeholder="Nama" value="{{ old('name', $type->name) }}">

                                    @error("name")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </div>

                        <div class="row">
                            <div class="col-sm-12">
                                <strong class="text-muted d-block mb-2">Deskripsi</strong>
                                <div class="form-group">
                                    <textarea type="description" rows="5" name="description" class="form-control @error('description') is-invalid @enderror" placeholder="Deskripsi tipe ujian...">{{ old('description', $type->description) }}</textarea>

                                    @error("description")
                                    <div class="invalid-feedback">{{ $message }}</div>
                                    @enderror
                                </div>
                            </div>
                        </div>

                        <div class="form__action">
                            <button type="submit" class="btn btn-success waves-effect waves-light mt-1 mb-1 mr-2">
                                <i class="mdi mdi-content-save mr-1"></i>Simpan
                            </button>
                            <a class="btn btn-secondary waves-effect waves-light text-white mt-1 mb-1" href="{{ route('administrator.types.index') }}">
                                <i class="mdi mdi-reply mr-1"></i>Batal
                            </a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/administrator/types/index.blade.php
@extends('administrator.layouts.template')

@section('css')
<link href="{{ asset('themes/ubold/') }}/libs/mohithg-switchery/switchery.min.css" rel="stylesheet" type="text/css" />
@endsection

@section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-12">
            <div class="page-title-box">
                <div class="page-title-right">
                    <ol class="breadcrumb m-0">
                        <li class="breadcrumb-item"><a href="{{ route('administrator.types.index') }}">Tipe Ujian</a></li>
                        <li class="breadcrumb-item active">Semua</li>
                    </ol>
                </div>

                <h4 class="page-title">Tipe Ujian</h4>
            </div>
        </div>
    </div>

    @if ($message = session()->get("success"))
    <div class="row">
        <div class="col-12">
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-check-all mr-2"></i>
                {{ $message }}
            </div>
        </div>
    </div>
    @endif

    @if ($errors->all())
    <div class="row">
        <div class="col-12">
            <div class="alert alert-danger alert-dismissible fade show" role="alert">
                <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                <i class="mdi mdi-alert-circle mr-2"></i>
                Something went wrong!
            </div>
        </div>
    </div>
    @endif

    <div class="row">
        <div class="col-sm-12">
            <div class="card">
                <div class="card-body">
                    <!-- <a href="{{ route('administrator.types.create') }}" class="float-right btn btn-sm btn-primary waves-effect waves-light float-right mb-3">
                        <i class="mdi mdi-plus-circle mr-1"></i>
                        Tambah Tipe Ujian
                    </a> -->

                    <div class="table-responsive mt-3">
                        <table class="table mb-0 table-hover table-borderless table-centered toggle-arrow-tiny" data-page-size="10">
                            <thead class="thead-light text-center">
                                <tr>
                                    <th style="width: 8%;">#</th>
                                    <th>Nama</th>
                                    <th>Deskripsi</th>
                                    <th>Aksi</th>
                                </tr>
                            </thead>
                            <tbody>
                                @forelse($types as $key => $type)
                                <tr>
                                    <td>{{ $key + 1 }}</td>
                                    <td>{{ $type->name }}</td>
                                    <td>{{ $type->description ?? '-' }}</td>
                                    <td class="text-center d-flex justify-content-center">
                                        <a href="{{ route('administrator.types.show', $type->id) }}" class="btn btn-sm btn-success waves-effect waves-light mr-1">
                                            <i class="mdi mdi-eye"></i>
                                        </a>
                                        <a href="{{ route('administrator.types.edit', $type->id) }}" class="btn btn-sm btn-info waves-effect waves-light mr-1">
                                            <i class="mdi mdi-pencil"></i>
                                        </a>
                                        {{
                                            Form::open([
                                                "method" => "DELETE",
                                                "route" => ["administrator.types.destroy", $type->id],
                                                "id" => "form-delete[".$type->id."]" 
                                            ])
                                        }}
                                        <!-- <button class="btn btn-sm btn-danger waves-effect waves-light" type="button" onclick="handleDelete(<?= $type->id ?>)">
                                            <i class="mdi mdi-delete"></i>
                                        </button> -->
                                        {{ Form::close() }}
                                    </td>
                                </tr>
                                @empty
                                <tr>
                                    <td colspan="4" class="text-center font-italic">Data not found</td>
                                </tr>
                                @endforelse
                            </tbody>
                            <tfoot>
                                <tr class="active">
                                    <td colspan="4">
                                        <div class="text-right">
                                            <ul class="pagination pagination-split justify-content-end footable-pagination m-t-10"></ul>
                                        </div>
                                    </td>
                                </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('javascript')
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>

<!-- Footable js -->
<script src="{{ asset('themes/ubold/libs/footable/footable.all.min.js') }}"></script>

<!-- Switchery js -->
<script src="{{ asset('themes/ubold/libs/mohithg-switchery/switchery.min.js') }}"></script>

<script>
    const handleDelete = (id) => {
        swal({
                title: "Are you sure?",
                text: "Once deleted, you will not be able to recover this item!",
                icon: "warning",
                buttons: true,
                dangerMode: true,
            })
            .then((willDelete) => {
                if (willDelete) {
                    document.getElementById(`form-delete[${ id }]`).submit();
                }
            });
    }

    $(".table").footable();
    $(".demo-show-entries").change(function(o) {
        o.preventDefault();
        var t = $(this).val();
        $(this).data("page-size", t), $(this).trigger("footable_initialized")
    });

    $('[data-plugin="switchery"]').each(function(e, a) {
        new Switchery($(this)[0], $(this).data());
    });
</script>
@endsection